﻿using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.SilverlightEdition;

namespace SilverlightApplication {
    public partial class _Default : System.Web.UI.Page {
        protected void Page_Load(object sender, EventArgs e) {
            if (!Page.IsPostBack) {
                string expression = "(ToInt32(POP_CNTRY)>5031379)";
                FleeBooleanStyle landLockedCountryStyle = GetFleeBooleanStyle(expression);

                ShapeFileFeatureLayer fleeBooleanWorldLayer = new ShapeFileFeatureLayer(MapPath("~/app_data/cntry02.shp"), ShapeFileReadWriteMode.ReadOnly);
                fleeBooleanWorldLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(landLockedCountryStyle);
                fleeBooleanWorldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                ServerLayerOverlay fleeBooleanOverlay = new ServerLayerOverlay("NativeServerWithFleeBoolean");
                fleeBooleanOverlay.Layers.Add(fleeBooleanWorldLayer);
                SilverlightMapConnector1.ServerLayerOverlays.Add(fleeBooleanOverlay);
            }
        }

        protected void FleeBooleanStyle1_Click(object sender, EventArgs e) {
            Button button = (Button)sender;
            ServerLayerOverlay overlay = SilverlightMapConnector1.ServerLayerOverlays[0];
            ShapeFileFeatureLayer fleeBooleanWorldLayer = (ShapeFileFeatureLayer)overlay.Layers[0];

            string expression = button.Text;
            FleeBooleanStyle landLockedCountryStyle = GetFleeBooleanStyle(expression);

            fleeBooleanWorldLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Clear();
            fleeBooleanWorldLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(landLockedCountryStyle);
            fleeBooleanWorldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
        }

        private static FleeBooleanStyle GetFleeBooleanStyle(string expression) {
            FleeBooleanStyle landLockedCountryStyle = new FleeBooleanStyle(expression);
            landLockedCountryStyle.StaticTypes.Add(typeof(System.Convert));

            landLockedCountryStyle.ColumnVariables.Add("POP_CNTRY");
            landLockedCountryStyle.CustomTrueStyles.Add(new AreaStyle(new GeoPen(GeoColor.SimpleColors.Green, 2), new GeoSolidBrush(GeoColor.FromArgb(100, GeoColor.SimpleColors.Green))));
            landLockedCountryStyle.CustomFalseStyles.Add(AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.FromArgb(100, GeoColor.SimpleColors.Green)));
            return landLockedCountryStyle;
        }
    }
}
