﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using ThinkGeo.MapSuite.Core;
using System.Reflection;
using System.IO;
using System.Collections.ObjectModel;

namespace SilverlightApplication {
    // NOTE: If you change the class name "GetGeoDataService" here, you must also update the reference to "GetGeoDataService" in Web.config.
    public class GetGeoDataService : IGetGeoDataService {
        private static ShapeFileFeatureSource featureSource;

        public GetGeoDataService() {
            string excutePath = Path.GetDirectoryName(Assembly.GetAssembly(typeof(GetGeoDataService)).CodeBase);
            string appPath = excutePath.Substring(excutePath.IndexOf('\\') + 1, excutePath.LastIndexOf('\\') - excutePath.IndexOf('\\') - 1);
            featureSource = new ShapeFileFeatureSource(appPath + @"\app_data\cntry02.shp");
        }

        public string GetData(double lon, double lat) {
            featureSource.Open();
            Collection<Feature> features = featureSource.SpatialQuery(new PointShape(lon, lat), QueryType.Contains, new string[] { "CNTRY_NAME", "POP_CNTRY", "COLOR_MAP" });
            featureSource.Close();
            StringBuilder stringBuilder = new StringBuilder();

            if (features.Count != 0) {
                stringBuilder.AppendFormat("{0}^{1}", features[0].ColumnValues["CNTRY_NAME"], features[0].ColumnValues["POP_CNTRY"]);
            }

            return JsonFeatureCollection.ConvertFeaturesToJson(features);
        }
    }
}
